#ifndef PROJECTSETTINGS_H
#define PROJECTSETTINGS_H

#define CMD_TO_LOAD_FILE "SENDFILE"
#define FRAMES 512                           // размер буфера для чтения, кол-во кадров
#define READDELAY 5000

#define MAX_DLC_SIZE 1
#define MAX_MACROS_RTR_SIZE 1
#define MAX_MACROS_EID_SIZE 1
#define MAX_MACROS_ID_SIZE 8
#define MAX_MACROS_HEX_SIZE 1
#define MAX_MACROS_NAME_SIZE 8
#define MAX_MACROS_SIZE 256

#define NORMAL_MSG_TO_LOGGER 0
#define WARNING_TO_LOGGER 1
#define GHOST_TO_LOGGER 2
#define TX_ERROR_EVENT 3
#define RX_ERROR_EVENT 4

#define RX_CAN_GROUP_TABLE_COUNT_COLUMN 0
#define RX_CAN_GROUP_TABLE_TIME_COLUMN 1
#define RX_CAN_GROUP_TABLE_PERIOD_COLUMN 2
#define RX_CAN_GROUP_TABLE_ID_COLUMN 3
#define RX_CAN_GROUP_TABLE_E_COLUMN 4
#define RX_CAN_GROUP_TABLE_R_COLUMN 5
#define RX_CAN_GROUP_TABLE_DLC_COLUMN 6
#define RX_CAN_GROUP_TABLE_DATA_COLUMN 7
#define RX_CAN_GROUP_TABLE_TMPS 8

#define RX_CAN_REQUESTER_GROUP_TABLE_COUNT_COLUMN 0
#define RX_CAN_REQUESTER_GROUP_TABLE_TIME_COLUMN 1
#define RX_CAN_REQUESTER_GROUP_TABLE_PERIOD_COLUMN 2
#define RX_CAN_REQUESTER_GROUP_TABLE_ID_COLUMN 3
#define RX_CAN_REQUESTER_GROUP_TABLE_ROUTE 4
#define RX_CAN_REQUESTER_GROUP_TABLE_DATATYPE 5
#define RX_CAN_REQUESTER_GROUP_TABLE_SENSORTYPE 6
#define RX_CAN_REQUESTER_GROUP_TABLE_SENSORID 7
#define RX_CAN_REQUESTER_GROUP_TABLE_DEVICE 8
#define RX_CAN_REQUESTER_GROUP_TABLE_E_COLUMN 9
#define RX_CAN_REQUESTER_GROUP_TABLE_R_COLUMN 10
#define RX_CAN_REQUESTER_GROUP_TABLE_DLC_COLUMN 11
#define RX_CAN_REQUESTER_GROUP_TABLE_DATA_COLUMN 12
#define RX_CAN_REQUESTER_GROUP_TABLE_TMPS 13

#include "chrono"
#include "QDebug"
#include "QTime"
#include "QMessageBox"
#include <QFileDialog>
#include "QTimer"
#include "QLineEdit"
#include "QCheckBox"
#include "QThread"
#include "QtConcurrent/QtConcurrent"


//#include "QTextCodec"

#include <QSerialPort>

#include "crc16.h"
#include "writeregistermodel.h"
#include "canusb.h"
#include "mainmenu.h"
#include "unioncom.h"
#include "usettingsrs.h"
#include "macrossetting.h"
#include "union_modbus.h"
#include "union_modbus_slave.h"
#endif // PROJECTSETTINGS_H
