QT -= gui

QT += core gui
QT += widgets serialport
QT += serialbus widgets

requires(qtConfig(combobox))

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

QT += serialport

TEMPLATE = lib
DEFINES += UNIONCOM_LIBRARY

CONFIG += c++11

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    canidcalc.cpp \
    canusb.cpp \
    crc16.cpp \
    macrossetting.cpp \
    main.cpp \
    mainmenu.cpp \
    union_modbus.cpp \
    union_modbus_slave.cpp \
    unioncom.cpp \
    usettingsrs.cpp \
    writeregistermodel.cpp

HEADERS += \
    ProjectSettings.h \
    canidcalc.h \
    canusb.h \
    crc16.h \
    macrossetting.h \
    mainmenu.h \
    slcan.h \
    union_modbus.h \
    union_modbus_slave.h \
    unioncom.h \
    usettingsrs.h \
    writeregistermodel.h

FORMS += \
    canidcalc.ui \
    canusb.ui \
    crc16.ui \
    macrossetting.ui \
    mainmenu.ui \
    union_modbus.ui \
    union_modbus_slave.ui \
    unioncom.ui \
    usettingsrs.ui


# Default rules for deployment.
unix {
    target.path = /usr/lib
}
!isEmpty(target.path): INSTALLS += target

win32: LIBS += -L$$PWD/./ -lslcan

#win32:CONFIG(release, debug|release): LIBS += -L$$PWD/./ -lslcan
#else:win32:CONFIG(debug, debug|release): LIBS += -L$$PWD/./ -lslcand
#else:unix: LIBS += -L$$PWD/./ -lslcan

#INCLUDEPATH += $$PWD/.
#DEPENDPATH += $$PWD/.
