#include "ProjectSettings.h"

#include <QApplication>

#define WITH_MEM_LEAK_TESTING
#ifdef WITH_MEM_LEAK_TESTING
    #define _CRTDBG_MAP_ALLOC
    #include <stdlib.h>
    #include <crtdbg.h>
#endif

int main(int argc, char *argv[])
{
#ifdef WITH_MEM_LEAK_TESTING
    _CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF);
#endif
    QApplication a(argc, argv);
    setlocale(LC_ALL, "");
    //Для отключения консоли при запуске нужно в файле .pro сделать: #CONFIG += console
    UnionCOM w;
    w.show();
    return a.exec();
}
